'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cliEngineHeroku = require('cli-engine-heroku');

class Whoami extends _cliEngineHeroku.Command {

  async run() {
    if (process.env.HEROKU_API_KEY) this.out.warn('HEROKU_API_KEY is set');
    if (!this.heroku.requestOptions.headers.authorization) this.notloggedin();
    try {
      let account = await this.heroku.get('/account');
      this.out.log(account.email);
    } catch (err) {
      if (err.statusCode === 401) this.notloggedin();
      throw err;
    }
  }

  notloggedin() {
    this.out.error('not logged in', 100);
  }
}
exports.default = Whoami;
Whoami.topic = 'auth';
Whoami.command = 'whoami';
Whoami.description = 'display the current logged in user';
Whoami.aliases = ['whoami'];